=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class ServiceGroupsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a new service group
    # Creates a new service group.
    # @param [Hash] opts the optional parameters
    # @option opts [BaseServiceGroup] :body 
    # @return [ServiceGroupResponse]
    def create_service_group(opts = {})
      data, _status_code, _headers = create_service_group_with_http_info(opts)
      data
    end

    # Create a new service group
    # Creates a new service group.
    # @param [Hash] opts the optional parameters
    # @option opts [BaseServiceGroup] :body 
    # @return [Array<(ServiceGroupResponse, Integer, Hash)>] ServiceGroupResponse data, response status code and response headers
    def create_service_group_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ServiceGroupsApi.create_service_group ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/service-groups/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'ServiceGroupResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ServiceGroupsApi#create_service_group\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a service group
    # Delete a service group by object ID.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_service_group(opts = {})
      delete_service_group_with_http_info(opts)
      nil
    end

    # Delete a service group
    # Delete a service group by object ID.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_service_group_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ServiceGroupsApi.delete_service_group ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/service-groups/{ServiceGroupId}/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ServiceGroupsApi#delete_service_group\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all service groups
    # List all service group objects.
    # @param [Hash] opts the optional parameters
    # @return [Array<ServiceGroupResponse>]
    def list_service_group(opts = {})
      data, _status_code, _headers = list_service_group_with_http_info(opts)
      data
    end

    # List all service groups
    # List all service group objects.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ServiceGroupResponse>, Integer, Hash)>] Array<ServiceGroupResponse> data, response status code and response headers
    def list_service_group_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ServiceGroupsApi.list_service_group ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/service-groups/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<ServiceGroupResponse>' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ServiceGroupsApi#list_service_group\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update an existing service group
    # PUT request to update an existing service group object. The object_id cannot be updated as it is the unique identifier for the object.
    # @param [Hash] opts the optional parameters
    # @option opts [ServiceGroup] :body 
    # @return [ServiceGroupResponse]
    def update_service_group(opts = {})
      data, _status_code, _headers = update_service_group_with_http_info(opts)
      data
    end

    # Update an existing service group
    # PUT request to update an existing service group object. The object_id cannot be updated as it is the unique identifier for the object.
    # @param [Hash] opts the optional parameters
    # @option opts [ServiceGroup] :body 
    # @return [Array<(ServiceGroupResponse, Integer, Hash)>] ServiceGroupResponse data, response status code and response headers
    def update_service_group_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ServiceGroupsApi.update_service_group ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/service-groups/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'ServiceGroupResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ServiceGroupsApi#update_service_group\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
